<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <!-- Popper Development version -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    
    <!-- Import DataTable Library --> 
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/jquery.dataTables.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  </head>

  <body>
    <div class="container">
      <div class="text-center mt-2 mb-2">
        <h2>F100 - QUẢN TRỊ NGƯỜI DÙNG</h2>
      </div>
      <div class="jumbotron container">
        <div class="row form-group">
          <div class="col-sm-3">
            <label for="voucherCodeInput">Role</label>
          </div>
          <div class="col-sm-6">
            <select id="roleSelect" class="form-control">
    
            </select>
          </div>
          <div class="col-sm-3">
            <button id="btn-filter-role" class="btn btn-info">Lọc dữ liệu</button>
          </div>
        </div>
    </div>
    
    <div class="container">
      <table class="table table-bordered table-striped table-hover" id="user-table">
        <thead class="thead-dark">
          <tr>
            <th scope='col'>STT</th>
            <th scope='col'>Username</th>
            <th scope='col'>First name</th>
            <th scope='col'>Last name</th>
            <th scope='col'>Email</th>
            <th scope='col'>Age</th>
            <th scope='col'>Role</th>
            <th scope='col'>Action</th>
          </tr>
        </thead>
        <tbody>
        </tbody>
      </table>
    </div>

    <script>
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      // Mảng gUserObjects là mảng chứa dữ liệu users
      var gUserObjects = [
        {
          id: 2,
          username: "quannv",
          firstname: "Ngo Van",
          lastname: "Quan",
          age: 18,
          email: "quan@gmail.com",
          roleId: 5,
        },
        {
          id: 3,
          username: "longdh",
          firstname: "Do Hoang",
          lastname: "Long",
          age: 19,
          email: "long@gmail.com",
          roleId: 8,
        },
        {
          id: 4,
          username: "hiendt",
          firstname: "Do Thi",
          lastname: "Hien",
          age: 29,
          email: "hien@gmail.com",
          roleId: 11,
        },
        {
          id: 6,
          username: "lanht",
          firstname: "Ho Thi",
          lastname: "Lan",
          age: 27,
          email: "lan@gmail.com",
          roleId: 13,
        },
      ];
      // Mảng gRoleObjects là mảng chứa dữ liệu các roles
      var gRoleObjects = [
        {
          roleId: 5,
          roleName: "Admin",
        },
        {
          roleId: 8,
          roleName: "Manager",
        },
        {
          roleId: 11,
          roleName: "Teacher",
        },
        {
          roleId: 13,
          roleName: "Staff",
        },
      ];

      var gUser = {
        username: "",
        firstname: "",
        lastname: ""
      };

      const ARRAY_NAME_COL = ['id', 'username', 'firstname', 'lastname', 'email', 'age', 'roleId', 'action'];
      const gCOL_ID = 0;
      const gCOL_USER_NAME = 1;
      const gCOL_FIRST_NAME = 2;
      const gCOL_LAST_NAME = 3;
      const gCOL_EMAIL = 4;
      const gCOL_AGE = 5;
      const gCOL_ROLE_ID = 6;
      const gCOL_ACTION = 7;
      var gSTT = 1;

      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      $(document).ready(function () {
        onPageLoading();

        $("#btn-filter-role").on("click", function(){
        onBtnFilterClick();
        });

        $("#user-table").on("click", "#dice-history", function () {
          onBtnDiceHistoryClick(this);
        });

        $("#user-table").on("click", "#voucher-history", function () {
          onBtnVoucherHistoryClick(this);
        });
      });

      
  
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
      function onPageLoading() {
        loadDataToRoleSelect();

        $('[data-toggle="tooltip"]').tooltip();
      }

      
      var gUserTable =  $("#user-table").DataTable({
          data: gUserObjects,
          columns: [
            {data: ARRAY_NAME_COL[gCOL_ID]},
            {data: ARRAY_NAME_COL[gCOL_USER_NAME]},
            {data: ARRAY_NAME_COL[gCOL_FIRST_NAME]},
            {data: ARRAY_NAME_COL[gCOL_LAST_NAME]},
            {data: ARRAY_NAME_COL[gCOL_EMAIL]},
            {data: ARRAY_NAME_COL[gCOL_AGE]},
            {data: ARRAY_NAME_COL[gCOL_ROLE_ID]},
            {data: ARRAY_NAME_COL[gCOL_ACTION]},
          ],
          columnDefs: [
            {
              targets: gCOL_ID, //cột STT
              className: "text-center text-primary",
              render: function (data, type, row, meta) {
                return meta.row + meta.settings._iDisplayStart + 1;
              }
            },
            {
              targets: gCOL_ROLE_ID,
              className: "text-right",
              render: mappingRoleNameByID
            },
            {
              targets: gCOL_ACTION,
              className: "text-center",
              defaultContent: `
                  <button class="btn btn-link" data-toggle="tooltip" data-placement="bottom" title="Dice History" id="dice-history"><i class="fas fa-dice text-success"></i></button>
                  <button class="btn btn-link btn-sm" data-toggle="tooltip" data-placement="bottom" title="Voucher History" id="voucher-history"><i class="fas fa-gift text-success"></i></button>`
            }
          ]
        });
      

      //hàm xử lý khi click nút lọc dữ liệu
      function onBtnFilterClick(){
        "use strict";
        //b0: tạo đối tượng chứ dữ liệu lọc
        var vFilter = {
          roleID: 0,
        };
        //b1: thu thập dữ liệu lọc
        getDataFromSelect(vFilter);
        //b2: kiểm tra

        //b3: lọc dữ liệu
        var vResultFilter = filterData(vFilter);
        console.log(vResultFilter);

        //b4: hiển thị kết quả lọc 
        displayDataToTable(vResultFilter);
      }

      function onBtnDiceHistoryClick(paramDataRow){
        //lấy data user
        gUser = getUserFromButton(paramDataRow);

        const vDETAIL_FORM_URL = "diceHistory.html";
        var vUrlSiteToOpen = vDETAIL_FORM_URL + "?user_name=" + gUser.username + "&first_name=" + gUser.firstname + "&last_name=" + gUser.lastname;
        location.href = vUrlSiteToOpen;
      }

      function onBtnVoucherHistoryClick(paramDataRow){
        //lấy data user
        gUser = getUserFromButton(paramDataRow);

        const vDETAIL_FORM_URL = "voucherHistory.html";
        var vUrlSiteToOpen = vDETAIL_FORM_URL + "?user_name=" + gUser.username + "&first_name=" + gUser.firstname + "&last_name=" + gUser.lastname;
        location.href = vUrlSiteToOpen;
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      function getUserFromButton(paramButton) {
      var vTableRow = $(paramButton).parents("tr");
      var vUserRowData = gUserTable.row(vTableRow).data();
      return vUserRowData;
    }
      
      //hàm hiển thị dữ liệu lọc lên datatable
      //input là dữ liệu cần hiển thị
      function displayDataToTable(paramData){
        "use strict";

        gSTT = 1; //thiết lập lại số thứ tự
        var vTable = $("#user-table").DataTable(); //truy xuất datatable
        vTable.clear(); //xóa dữ liệu của datatable
        vTable.rows.add(paramData); // thêm các dòng dữ liệu và datatable
        vTable.draw();
      }

      //hàm lọc dữ liệu
      //input là điều kiện lọc
      //output là kết quả lọc
      function filterData(paramFilter){
        "use strict";
        var vResult = [];
        vResult = gUserObjects.filter(function(item){
          return (item.roleId == paramFilter.roleId || paramFilter.roleId == 0);
        });
        return vResult;
      }

      //hàm thu thập dữ liệu lọc
      //input là đối tượng chứ dữ liệu lọc
      function getDataFromSelect(paramObj){
        "use strict";
        paramObj.roleId = $("#roleSelect").val();
      }

      function mappingRoleNameByID(paramData, paramType, paramRow) {
        for (let bI = 0; bI < gRoleObjects.length; bI++) {
          const bRoleObjItem = gRoleObjects[bI];
          if (paramData == bRoleObjItem.roleId) {
            return bRoleObjItem.roleName;
          }
        }
      }

      function loadDataToRoleSelect() {
        var vRoleSelect = $("#roleSelect");
        $("<option/>", {
          text: "--- Chọn tất cả ---",
          value: 0
        }).appendTo(vRoleSelect);

        for (let bI = 0; bI < gRoleObjects.length; bI++) {
          var bPizzaTypeOption = $("<option/>", {
            text: gRoleObjects[bI].roleName,
            value: gRoleObjects[bI].roleId
          }).appendTo(vRoleSelect);
        }
      }
    </script>
  </body>
</html>
